<?php

define('LICENCE_ANONYMOUS', -1);
define('LICENCE_USER', 0);
define('LICENCE_MODERATOR', 1);
define('LICENCE_ADMIN', 2);

function utf2ascii($text)
{
  $return = Str_Replace(
    Array("á","č","ď","é","ě","í","ľ","ň","ó","ř","š","ť","ú","ů","ý","ž","Á","Č","Ď","É","Ě","Í","Ľ","Ň","Ó","Ř","Š","Ť","Ú","Ů","Ý","Ž") ,
    Array("a","c","d","e","e","i","l","n","o","r","s","t","u","u","y","z","A","C","D","E","E","I","L","N","O","R","S","T","U","U","Y","Z") ,
    $text);
  //$return = Str_Replace(Array(" ", "_"), "-", $return); //nahradí mezery a podtržítka pomlčkami
  //$return = Str_Replace(Array("(",")",".","!",",","\"","'"), "", $return); //odstraní ().!,"'
  //$return = StrToLower($return); // velká písmena nahradí malými.
  return($return);
}

function getmonthyears($Days) 
{
	$month = floor($Days / 30);
	$year = floor($month / 12);
	$Days = floor($Days - $month * 30);
	$month = $month - $year * 12;	
	return($year.'r '.$month.'m '.$Days.'d');
}

function ListPaging($Address, $Table, $Where, $ItemsPerPage, $CurrentPage)
{
  global $Database;
  	
  echo('<div style="text-align: center">');
  $Line = mysql_fetch_row($Database->SQLCommand('SELECT count(*) FROM '.$Table.' '.$Where));        
  $ItemCount = $Line[0];
  $PageCount = floor($ItemCount / $ItemsPerPage) + 1;
        
  echo('Počet položek: <strong>'.$ItemCount.'</strong> &nbsp; Zobrazit stránku: ');

  //if($CurrentPage > $PageCount) $CurrentPage = $PageCount;
  for($Page = 1; $Page <= $PageCount; $Page++) 
  {
    if($CurrentPage == $Page) echo('<strong>'.$Page.'</strong> ');
      else echo('<a href="'.$Address.$Page.'">'.$Page.'</a> ');
  }
  echo('</div>');
}

function FormatOutput($s)
{
    $out = '';
    $nn = 0;
    $n = 0;
    while($s!='')
    {
      $start = strpos($s,'<');
  	  $end = strpos($s,'>');
    	if($start != 0) 
    	{
	      $end = $start-1;
	      $start = 0;
	    }
	    $line = trim(substr($s,$start,$end+1));
	    if(strlen($line)>0) 
	    if($line[0] == '<')
	    {
  	    if($s[$start+1] == '/') 
	      {
  	      $n = $n - 2;
		      $nn = $n;
	      } else 
	      {
     	    if(strpos($line,' ')) $cmd = substr($line,1,strpos($line,' ')-1);
	        else $cmd = substr($line,1,strlen($line)-2);
          //echo('['.$cmd.']');
		      if(strpos($s,'</'.$cmd.'>')) $n = $n + 2;
	      }   
	    }// else $line = '['.$line.']';
      //if($line != '') echo(htmlspecialchars(str_repeat(' ',$nn).$line."\n"));
	    if($line != '') $out .= (str_repeat(' ',$nn).$line."\n");
	    $s = substr($s,$end+1,strlen($s));
	    $nn = $n;
    }
    return($out);
}

function WriteLanguages($Selected)
{
  global $LanguageList;
  
  echo('<select name="Language">');
  foreach($LanguageList as $Language)
  if($Language['Enabled'] == 1)
  {
    echo('<option value="'.$Language['Id'].'"'); 
    if($Selected == $Language['Id']) echo(' selected="selected"'); echo('>'.$Language['Name'].'</option>');
  }    
  echo('</select>');  	
}

function WriteLanguagesWithoutSel($Selected)
{
  global $LanguageList;
  
  foreach($LanguageList as $Language)
  {
    if($Selected == $Language['Id']) echo($Language['Name']);
  }
}

function Licence($Licence)
{
  global $Database;
 
  if($Licence == -1) return(true);
  else
  if(isset($_SESSION['User']) and ($_SESSION['User'] <> '') and ($_SESSION['UserID'] != '')) 
  {
    //  $User = $_SESSION['User'];
    $Pass = $_SESSION['Pass'];
    $Line = mysql_fetch_array($Database->SQLCommand('SELECT * FROM user WHERE ID = '.$_SESSION['UserID'].'
      AND GM >= '.$Licence.' AND pass = sha1("'.$Pass.'")'));
    //  echo "SELECT * FROM user WHERE ID = ".$_SESSION['UserID']." AND GM <= $Licence AND pass = '$Pass'";
    return($Line);
  } else 
  { 
	return(false);
  }
}

function MysqlDateTimeToTime($Time)
{
  $Parts = explode(' ', $Time);
  $DateParts = explode('-', $Parts[0]); 
  $TimeParts = explode(':', $Parts[1]);
  $Result = mktime($TimeParts[0], $TimeParts[1], $TimeParts[2], $DateParts[1], $DateParts[2], $DateParts[0]); 
  return($Result);  
}

function GetLanguageList()
{ 
  global $Database;
  
  $Result = array();
  $DbResult = $Database->SQLCommand('SELECT * FROM `language`');
  while($DbRow = mysql_fetch_assoc($DbResult))
	  $Result[$DbRow['Id']] = $DbRow;
  return($Result);
}

function GetTranslationTree()
{ 
  global $Database;
  
  $Result = array();
  $DbResult = $Database->SQLCommand('SELECT * FROM `group`');
  while($DbRow = mysql_fetch_assoc($DbResult))
  {
	  $DbRow['Items'] = array();
	  $Result[$DbRow['Id']] = $DbRow;
  }
  $DbResult = $Database->SQLCommand('SELECT * FROM `group_item`');
  while($DbRow = mysql_fetch_assoc($DbResult))
  {
	  $Result[$DbRow['Group']]['Items'][] = $DbRow;
  }
  return($Result);
}

$LogTypes = array
(
  //    index,   indexname  , barva ,  popis
  array('0', '', 'brown', ''), 
  array('1', 'Překlady', 'green', 'Operace s překladdy'),
  array('2', 'Stažení', 'brown', 'Stáhnutí souboru'),
  array('3', 'Uživatelé', 'blue', 'Přihlášení uživatelů, nastavení, registrace'),
  array('4', 'Moderátor', 'orange', 'Operace administrátorů a moderátorů'),
  array('10', 'Chyby', 'red', 'Zachycené chybové hlášení'),
  array('11', 'Import', '#A020F0', 'Záznam změn při importu'),
);

$Moderators = array('Překladatel', 'Moderátor', 'Administrátor');

function WriteLog($Text, $Type)
{
  global $Database, $Config;
 
  $user = @$_SESSION['UserID'];
  if($user == '') $user = 0;
  $Database->SelectDatabase($Config['Database']['Database']);    
  $Query = 'INSERT INTO `log` ( `user` , `type` , `text` , `date` , `IP` )
   VALUES ('.$user.', '.$Type.', "'.addslashes($Text).'", NOW(), "'.addslashes($_SERVER['REMOTE_ADDR']).'")';
  $Database->SQLCommand($Query);
}

$client_files = array
(
  '0' => 'LocalizationStrings',
  '1' => 'SpellBufDescription_1',
  '2' => 'SpellDescription_1',
  '3' => 'SpellDescription_2',
  '4' => 'SpellDescription_3',
  '5' => 'SpellDescription_4',
  '6' => 'tallent',
);

function HumanDate($SQLDateTime)
{
  $DateTimeParts = explode(' ', $SQLDateTime);
  $DateParts = explode('-', $DateTimeParts[0]);
  return(($DateParts[2] * 1).'.'.($DateParts[1] * 1).'.'.($DateParts[0] * 1));
}

function FollowingTran($TextID, $Table, $GroupId, $Prev = false) 
{ 
  global $Database;
  
  if($Prev)
  {
  	$sql = 'SELECT ID FROM '.$Table.' as item WHERE Language = 0 AND NOT EXISTS(SELECT entry FROM '.$Table.' AS sub WHERE sub.Language <> 0 AND sub.entry = item.entry) AND ID < '.$TextID.' ORDER BY ID DESC LIMIT 1';
  } else
  {
  	$sql = 'SELECT ID FROM '.$Table.' as item WHERE Language = 0 AND NOT EXISTS(SELECT entry FROM '.$Table.' AS sub WHERE sub.Language <> 0 AND sub.entry = item.entry) AND ID > '.$TextID.' ORDER BY ID LIMIT 1';
  }
  
  $Next = mysql_fetch_assoc($Database->SQLCommand($sql));
  if($Next) 
  {
  	if($Prev) echo('<a href="form.php?group='.$GroupId.'&amp;ID='.$Next['ID'].'">Předcházející '.$Next['ID'].'</a> ');
  	else echo('<a href="form.php?group='.$GroupId.'&amp;ID='.$Next['ID'].'">Následující '.$Next['ID'].'</a> ');
  		 return 'form.php?group='.$GroupId.'&amp;ID='.$Next['ID'];
  }
}


function HaveSameText($Group, $DbRow2, $Value)
{
  $result = true;
  foreach($Group['Items'] as $GroupItem) 
  {
    $old = $DbRow2[$GroupItem['Column']];
    $old = str_replace(chr(10), '', $old);
    $old = str_replace(chr(13), '', $old);
    $old = str_replace('\n', '', $old);
    $old = str_replace('\r', '', $old);
    $old = str_replace('\"', '"', $old);
    $old = str_replace('\\\\', '\\', $old);
    $old = str_replace('\32', '32', $old);
    $old = str_replace('\124', '124', $old);
    $old = str_replace("\'", "'", $old);
    $old = str_replace("Â", "", $old);
    $old = str_replace("�", "", $old);
	
  
    if ($GroupItem['MangosColumn'] <> '')  
      $new = $Value[$GroupItem['MangosColumn']];
    else
      $new = $Value[$GroupItem['Column']];
    $new = str_replace(chr(10), '', $new);
    $new = str_replace(chr(13), '', $new);
    $new = str_replace('\n', '', $new);
    $new = str_replace('\r', '', $new);
    $new = str_replace('\"', '"', $new);
    $new = str_replace('\\\\', '\\', $new);
    $new = str_replace('\32', '32', $new);
    $new = str_replace('\124', '124', $new);
    $new = str_replace("\'", "'", $new);
    $new = str_replace("Â", "", $new);
    $new = str_replace("�", "", $new);

    if(($old <> $new) and ($GroupItem['Column'] <> 'Comment')) 
    {
      //  echo $old.'X'.$new;
      $result = false;
    }
  }
  return($result);
}


function GetBuildNumber($Version)
{
  global $Database;
	
  $sql = 'SELECT BuildNumber FROM `wow_client_version` WHERE Version = "'.$Version.'"';
  $BuildNumber = mysql_fetch_assoc($Database->SQLCommand($sql));
  return($BuildNumber['BuildNumber']);
}

function GetVersionWOW($BuildNumber)
{
  global $Database;
	
  $sql = 'SELECT Version FROM `wow_client_version` WHERE BuildNumber = "'.$BuildNumber.'"';
  $Version = mysql_fetch_assoc($Database->SQLCommand($sql));
  return($Version['Version']);
}

function GetDBCColumns($Version,$DBCFileName)
{
  global $Database;
	
  $sql = 'SELECT DBCColumns_'.$DBCFileName.' as DBCColumns FROM `wow_client_version` WHERE Version = "'.$Version.'"';
  $DbRow = mysql_fetch_assoc($Database->SQLCommand($sql));
  return($DbRow['DBCColumns']);
}

function GetDBCColumnIndex($Version,$DBCFileName,$Column)
{
  global $Database;
	
  $sql = 'SELECT '.$DBCFileName.'_'.$Column.' as DBCColumns FROM `wow_client_version` WHERE Version = "'.$Version.'"';
  $DbRow = mysql_fetch_assoc($Database->SQLCommand($sql));
  return($DbRow['DBCColumns']);
}

?>
